define(
    [
        'marionette',
        'backbone'
    ], function (Marionette, Backbone) {
        'use strict';

        var vent = new Backbone.Wreqr.EventAggregator();

        vent.Events = {
            SeriesAdded        : 'series:added',
            SeriesDeleted      : 'series:deleted',
            CommandComplete    : 'command:complete',
            ServerUpdated      : 'server:updated',
            EpisodeFileDeleted : 'episodefile:deleted'
        };

        vent.Commands = {
            EditSeriesCommand         : 'EditSeriesCommand',
            DeleteSeriesCommand       : 'DeleteSeriesCommand',
            OpenModalCommand          : 'OpenModalCommand',
            CloseModalCommand         : 'CloseModalCommand',
            ShowEpisodeDetails        : 'ShowEpisodeDetails',
            ShowHistoryDetails        : 'ShowHistoryDetails',
            ShowLogDetails            : 'ShowLogDetails',
            SaveSettings              : 'saveSettings',
            ShowLogFile               : 'showLogFile',
            ShowRenamePreview         : 'showRenamePreview',
            OpenControlPanelCommand   : 'OpenControlPanelCommand',
            CloseControlPanelCommand  : 'CloseControlPanelCommand'
        };

        vent.Hotkeys = {
            NavbarSearch : 'navbar:search',
            SaveSettings : 'settings:save',
            ShowHotkeys  : 'hotkeys:show'
        };

        return vent;
    });
